program prog
  use ISO_FORTRAN_ENV
  implicit none
  character(len=:), allocatable :: nom_fichier_acopier, nom_fichier_copie
  character(len=:), allocatable :: nom_executable
  character(len=:), allocatable :: bloc, buffer
  integer taille_bloc, in_unit, out_unit, ios
  integer long
  namelist /param/ taille_bloc

  call get_command_argument( number=0, length=long )
  allocate( character(len=long) :: nom_executable )
  call get_command_argument( number=0, value=nom_executable )
  if ( command_argument_count() /= 2 ) call usage
  call get_command_argument( number=1, length=long )
  allocate( character(len=long) :: nom_fichier_acopier )
  call get_command_argument( number=1, value=nom_fichier_acopier )
  call get_command_argument( number=2, length=long )
  allocate( character(len=long) :: nom_fichier_copie )
  call get_command_argument( number=2, value=nom_fichier_copie )

  open( newunit=in_unit, &
        file="exo2.nml", &
        action="read",   &
        status="old",    &
        form="formatted" )
  read( unit=in_unit, nml=param )
  close( unit=in_unit )

  open( newunit=in_unit,          &
        file=nom_fichier_acopier, &
        action="read",            &
        status="old",             &
        form="formatted" )

  open( newunit=out_unit,       &
        file=nom_fichier_copie, &
        action="write",         &
        status="replace",       &
        form="formatted" )

  write( OUTPUT_UNIT, * ) &
         "La lecture s'effectuera avec des blocs de ", &
          taille_bloc, "octets."
  allocate( character(len=taille_bloc):: bloc )
  do
    ios = lire_enreg( ZONE=buffer )
    if ( is_iostat_end( ios ) ) exit
    write( unit=out_unit, fmt='(a)' ) trim(buffer)
  end do
  !deallocate( buffer )
  close( unit=in_unit )
  close( unit=out_unit )
CONTAINS
  function lire_enreg( zone ) result(ios)
    character(len=:), allocatable :: zone
    character(len=:), allocatable :: zone_etendue
    integer :: ios
    integer :: nb_blocs, nb_car

    read( unit=in_unit, fmt='(a)', advance='no', iostat=ios ) bloc
    if ( is_iostat_end( ios ) ) return
    zone = bloc
    if ( .not.is_iostat_eor( ios ) ) then
      nb_blocs = 2
      do
        allocate( character(len=nb_blocs*taille_bloc) :: zone_etendue )
        nb_car = len(zone)
        zone_etendue(1:nb_car) = zone
        call MOVE_ALLOC( TO=zone, FROM=zone_etendue )
        read( unit=in_unit, fmt='(a)', advance='no', iostat=ios )&
                        zone(nb_car+1:)
        if ( is_iostat_eor( ios ) ) exit
        nb_blocs = nb_blocs + 1
      end do
      !print *,"NB_BLOCS = ", nb_blocs
    end if
  end function lire_enreg
!
  subroutine usage 
    write( ERROR_UNIT, '(3a)' ) &
             "Usage : ", nom_executable, " fichier1 fichier2"
    stop 4
  end subroutine usage 
end program prog
