module GestionMenu
  use ISO_FORTRAN_ENV, only : INPUT_UNIT, ERROR_UNIT
  implicit none
  abstract interface
    subroutine modele
    end subroutine modele
  end interface

  type menu
    character(:),          allocatable :: texte
    procedure(modele), nopass, pointer :: action
  contains
    procedure, pass :: affichage_texte
  end type menu

contains

  function SelectionMenu(tab_menu, NbChoix) result(choix)
    type(menu), dimension(:), intent(in) :: tab_menu
    integer,                  intent(in) :: NbChoix
    integer choix
    integer choix_saisi, ios

    do
      print '(//,a)', "Liste des choix :"
      do choix=1, NbChoix
        print *, tab_menu(choix)%texte
      end do
      read( INPUT_UNIT, *, iostat=ios) choix_saisi
      if (ios == 0) then
        if(choix_saisi >= 1 .AND. choix_saisi <= NbChoix) then
          choix = choix_saisi
          exit
        end if
      elseif (ios < 0) then
        choix = NbChoix
        exit
      end if
      write( ERROR_UNIT, '(/,a)') "ERREUR - choix invalide."
    end do
  end function SelectionMenu

  subroutine ajouts
    print '(/,a,/)', 'Choix "AJOUTS" selectionne.'
  end subroutine ajouts
  subroutine affichage
    print '(/,a,/)', 'Choix "AFFICHAGE" selectionne.'
  end subroutine affichage
  subroutine tri
    print '(/,a,/)', 'Choix "TRI" selectionne.'
  end subroutine tri
  subroutine suppression
    print '(/,a,/)', 'Choix "SUPPRESSION" selectionne.'
  end subroutine suppression
  subroutine vider
    print '(/,a,/)', 'Choix "VIDER" selectionne.'
  end subroutine vider
  subroutine arret
    print '(/,a,/)', 'Choix "ARRET" selectionne.'
    stop
  end subroutine arret

  subroutine affichage_texte(this)
    class(menu), intent(in) :: this

    print '(//,a)', this%texte
  end subroutine affichage_texte
end module GestionMenu

program TestMenu
  use GestionMenu
  implicit none
  type proc
    procedure(modele), nopass, pointer :: p
  end type proc
  integer,    parameter          :: NbChoix = 6
  type(menu), dimension(NbChoix) :: tab_menu
  character(len=*), parameter, dimension(NbChoix) :: tab_chaines = &
            [ "1 - AJOUTS d'lments dans une liste chane.", &
              "2 - AFFICHAGE de la liste chane.           ", &
              "3 - TRI de la liste chane.                 ", &
              "4 - SUPPRESSION d'lments dans la liste.    ", &
              "5 - VIDER la liste.                          ", &
              "6 - ARRT du programme.                      " ]
  type(proc), dimension(:), allocatable :: tab_procs
  integer choix

  tab_procs = [ proc(ajouts),      proc(affichage), proc(tri), &
                proc(suppression), proc(vider),     proc(arret) ]
  do choix=1, NbChoix
    tab_menu(choix) = menu(tab_chaines(choix), tab_procs(choix)%p)
  end do

  do
    choix = SelectionMenu(tab_menu, NbChoix)
    call tab_menu(choix)%affichage_texte
    call tab_menu(choix)%action
  end do
end program TestMenu

