submodule(mat_cmplx) smat_cmplx
  use f95_lapack, only: GEEV => LA_GEEV, HEEV => LA_HEEV
  implicit none

contains

  module function matrice_cmplx_f(fichier)
    character(len=*), intent(in) :: fichier
    character(len=30)            :: type_matrice
    type(matrice_cmplx)          :: matrice_cmplx_f
    integer n, i, j, unite

    associate(t => matrice_cmplx_f)
      open( newunit=unite,         &
            file=fichier,          &
            action="read",         &
            form="formatted",      &
            access="sequential" )
      read(unit=unite, fmt='(a, /, i4)') type_matrice, n
      t%ordre = n
      t%type = type_matrice
      allocate(t%mat(n, n))
      allocate(t%valp(n))
      read(unit=unite, fmt=*) ((t%mat(i,j),j=1,n),i=1,n)
      close(unit=unite)
      call matrice_cmplx_f%sorties(init=.true.)
    end associate
  end function matrice_cmplx_f

  module subroutine propres_cmplx(this)
    class(matrice_cmplx), intent(inout) :: this

    call geev(this%mat, this%valp)
  end subroutine propres_cmplx

  module subroutine sorties_cmplx(this, init)
    class(matrice_cmplx), intent(in) :: this
    logical,    optional, intent(in) :: init
    logical init_loc
    integer i

    if (     present(init)) init_loc = init
    if (.NOT.present(init)) init_loc = .false.

    if (init_loc) then
      print '(//, t20, a, /)', this%type
      do i=1,size(this%mat,1)
        print trim(this%format_sortie_mat), this%mat(i,:)
      end do
    else
      print '(//, t20, "Valeurs propres", /)'
      do i=1,size(this%valp)
        print trim(this%format_sortie_valp), i, this%valp(i)
      end do
    end if
  end subroutine sorties_cmplx
end submodule smat_cmplx
