submodule(mat_hermitienne) smat_hermitienne
  use la_precision, only: WP=>DP
  use f95_lapack,   only: HEEV => LA_HEEV
  implicit none

contains

  module function matrice_hermitienne_f(fichier)
    character(len=*), intent(in) :: fichier
    type(matrice_hermitienne)    :: matrice_hermitienne_f

    matrice_hermitienne_f%matrice_cmplx = matrice_cmplx(fichier)
  end function matrice_hermitienne_f

  module subroutine propres_hermitienne(this)
    class(matrice_hermitienne), intent(inout)  :: this
    REAL(WP), DIMENSION(:), ALLOCATABLE :: W
    integer n

    n = this%get_ordre()
    allocate(W(n))
    call heev(this%mat, w)
    this%valp(:) = W(:)
    deallocate(W)
  end subroutine propres_hermitienne
end submodule smat_hermitienne
