submodule(mat_real_sym_vecp) smat_real_sym_vecp
  use la_precision, only: WP=>DP
  use f95_lapack,   only: SYEV => LA_SYEV
  implicit none

contains

  module function matrice_reelle_sym_vecp_f(fichier)
    character(len=*), intent(in)  :: fichier
    type(matrice_reelle_sym_vecp) :: matrice_reelle_sym_vecp_f
    integer n

    matrice_reelle_sym_vecp_f%matrice_reelle_sym = matrice_reelle_sym(fichier)
    n = matrice_reelle_sym_vecp_f%get_ordre()
    allocate(matrice_reelle_sym_vecp_f%vecp(n,n))
  end function matrice_reelle_sym_vecp_f

  module subroutine propres_reelle_sym_vecp(this)
    class(matrice_reelle_sym_vecp), intent(inout) :: this
    REAL(WP), ALLOCATABLE :: w(:)
    integer n

    n = this%get_ordre()
    allocate(w(n))
    call syev(this%mat, w , JOBZ='V', UPLO='L')
    this%valp(:) = w(:)
    this%vecp(:,:) = this%mat(:,:)
  end subroutine propres_reelle_sym_vecp

  module subroutine sorties_reelle_sym_vecp(this, init)
    class(matrice_reelle_sym_vecp), intent(in) :: this
    logical,              optional, intent(in) :: init
    integer i

    call this%matrice_reelle%sorties(init)
    print '(//, t20, a, /)', "Vecteurs propres"
    do i=1,size(this%vecp,1)
      print trim(this%format_sortie_vecp), this%vecp(i,:)
    end do
  end subroutine sorties_reelle_sym_vecp
end submodule smat_real_sym_vecp
