submodule(mat_real_vecp) smat_real_vecp
  use la_precision, only: WP=>DP
  use f95_lapack,   only: GEEV => LA_GEEV
  implicit none

contains

  module function matrice_reelle_vecp_f(fichier)
    character(len=*), intent(in) :: fichier
    type(matrice_reelle_vecp)    :: matrice_reelle_vecp_f
    integer n

    matrice_reelle_vecp_f%matrice_reelle = matrice_reelle(fichier)
    n = matrice_reelle_vecp_f%get_ordre()
    allocate(matrice_reelle_vecp_f%vecp(n,n))
  end function matrice_reelle_vecp_f

  module subroutine propres_reelle_vecp(this)
    class(matrice_reelle_vecp), intent(inout) :: this
    REAL(WP), ALLOCATABLE :: VR(:,:)
    REAL(WP), DIMENSION(:), ALLOCATABLE :: WR, WI
    integer n

    n = this%get_ordre()
    allocate(WR(n), WI(n), vr(n,n))
    call geev(this%mat, WR, WI, VR=vr)
    this%valp(:) = cmplx(WR(:), WI(:), kind=WP)
    deallocate(WR, WI)
    this%vecp(:,:) = recup_vect_propres()
    deallocate(vr)
    contains
      function recup_vect_propres()
        complex(kind=WP), dimension(n,n) :: recup_vect_propres
        logical saut_indice
        integer i
  
        saut_indice = .false.
        do i=1,n
          if (AIMAG(this%valp(i)) == 0.) then
            recup_vect_propres(:,i) = vr(:,i)
          else if (saut_indice) then
            saut_indice = .false.
            cycle
          else
            recup_vect_propres(:,i)   = &
                           cmplx(vr(:,i),  vr(:,i+1), kind=WP)
            recup_vect_propres(:,i+1) = &
                           cmplx(vr(:,i), -vr(:,i+1), kind=WP)
            saut_indice = .true.
          end if
        end do
      end function recup_vect_propres
  end subroutine propres_reelle_vecp

  module subroutine sorties_reelle_vecp(this, init)
    class(matrice_reelle_vecp), intent(in) :: this
    logical,          optional, intent(in) :: init
    integer i

    call this%matrice_reelle%sorties(init)
    print '(//, t20, a, /)', "Vecteurs propres"
    do i=1,size(this%vecp,1)
      print this%format_sortie_vecp, this%vecp(i,:)
    end do
  end subroutine sorties_reelle_vecp
end submodule smat_real_vecp
