module mat_real
  use la_precision, only: WP=>DP
  use mat_base

  type, extends(matrice) :: matrice_reelle
    private
    real(kind=WP),    dimension(:,:), allocatable :: mat
    complex(kind=WP), dimension(:),   allocatable :: valp
    character(len=100) :: format_sortie_mat = "(*(:,es10.3, 2x))"
    character(len=100) :: format_sortie_valp = &
                   '("Valeur propre N.",i2," : (",es10.3,"  , ",es10.3,")")'
  contains
    procedure :: propres => propres_reelle
    procedure :: sorties => sorties_reelle
  end type matrice_reelle

  type, extends(matrice_reelle) :: matrice_reelle_vecp
    private
    complex(kind=WP), dimension(:,:), allocatable :: vecp
    character(len=100) :: format_sortie_vecp = &
                   '(*(:,"(",f6.3,",",f6.3,")",1x))'
  contains
    procedure :: propres => propres_reelle_vecp
    procedure :: sorties => sorties_reelle_vecp
  end type matrice_reelle_vecp

  type, extends(matrice_reelle) :: matrice_reelle_sym
    private
  contains
    procedure :: propres => propres_reelle_sym
  end type matrice_reelle_sym

  type, extends(matrice_reelle_sym) :: matrice_reelle_sym_vecp
    private
    real(kind=WP), dimension(:,:), allocatable :: vecp
    character(len=100) :: format_sortie_vecp = "(*(:,es10.3, 2x))"
  contains
    procedure :: propres => propres_reelle_sym_vecp
    procedure :: sorties => sorties_reelle_sym_vecp
  end type matrice_reelle_sym_vecp

  interface matrice_reelle
    module function matrice_reelle_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_reelle)         :: matrice_reelle_f
    end function matrice_reelle_f
  end interface matrice_reelle

  interface matrice_reelle_vecp
    module function matrice_reelle_vecp_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_reelle_vecp)    :: matrice_reelle_vecp_f
    end function matrice_reelle_vecp_f
  end interface matrice_reelle_vecp

  interface matrice_reelle_sym
    module function matrice_reelle_sym_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_reelle_sym)     :: matrice_reelle_sym_f
    end function matrice_reelle_sym_f
  end interface matrice_reelle_sym

  interface matrice_reelle_sym_vecp
    module function matrice_reelle_sym_vecp_f(fichier)
      character(len=*), intent(in)  :: fichier
      type(matrice_reelle_sym_vecp) :: matrice_reelle_sym_vecp_f
    end function matrice_reelle_sym_vecp_f
  end interface matrice_reelle_sym_vecp

  interface
    module subroutine propres_reelle(this)
      class(matrice_reelle), intent(inout) :: this
    end subroutine propres_reelle
    module subroutine sorties_reelle(this, init)
      class(matrice_reelle), intent(in) :: this
      logical, optional, intent(in)     :: init
    end subroutine sorties_reelle

    module subroutine propres_reelle_vecp(this)
      class(matrice_reelle_vecp), intent(inout) :: this
    end subroutine propres_reelle_vecp
    module subroutine sorties_reelle_vecp(this, init)
      class(matrice_reelle_vecp), intent(in) :: this
      logical, optional, intent(in)          :: init
    end subroutine sorties_reelle_vecp

    module subroutine propres_reelle_sym(this)
      class(matrice_reelle_sym), intent(inout) :: this
    end subroutine propres_reelle_sym

    module subroutine propres_reelle_sym_vecp(this)
      class(matrice_reelle_sym_vecp), intent(inout) :: this
    end subroutine propres_reelle_sym_vecp
    module subroutine sorties_reelle_sym_vecp(this, init)
      class(matrice_reelle_sym_vecp), intent(in) :: this
      logical, optional, intent(in)              :: init
    end subroutine sorties_reelle_sym_vecp
  end interface
end module mat_real
