module mat_cmplx
  use la_precision, only: WP=>DP
  use mat_base
  implicit none

  type, extends(matrice) :: matrice_cmplx
    !private
    complex(kind=WP), dimension(:,:), allocatable :: mat
    complex(kind=WP), dimension(:),   allocatable :: valp
    character(len=100) :: format_sortie_mat = &
                   '(*(:,"(",f6.3,",",f6.3,")",1x))'
    character(len=100) :: format_sortie_valp = &
                   '("Valeur propre N.",i2," : (",es10.3,"  , ",es10.3,")")'
  contains
    procedure :: propres => propres_cmplx
    procedure :: sorties => sorties_cmplx
  end type matrice_cmplx

  interface matrice_cmplx
    module function matrice_cmplx_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_cmplx)          :: matrice_cmplx_f
    end function matrice_cmplx_f
  end interface matrice_cmplx

  interface
    module subroutine propres_cmplx(this)
      class(matrice_cmplx), intent(inout) :: this
    end subroutine propres_cmplx
    module subroutine sorties_cmplx(this, init)
      class(matrice_cmplx), intent(in) :: this
      logical, optional, intent(in)    :: init
    end subroutine sorties_cmplx
  end interface
end module mat_cmplx
