module mat_hermitienne_vecp
  use la_precision, only: WP=>DP
  use mat_hermitienne

  type, extends(matrice_hermitienne) :: matrice_hermitienne_vecp
    !private
    complex(kind=WP), dimension(:,:), allocatable :: vecp
    character(len=100) :: format_sortie_vecp = &
                   '(*(:,"(",f6.3,",",f6.3,")",1x))'
  contains
    procedure :: propres => propres_hermitienne_vecp
    procedure :: sorties => sorties_hermitienne_vecp
  end type matrice_hermitienne_vecp

  interface matrice_hermitienne_vecp
    module function matrice_hermitienne_vecp_f(fichier)
      character(len=*), intent(in)   :: fichier
      type(matrice_hermitienne_vecp) :: matrice_hermitienne_vecp_f
    end function matrice_hermitienne_vecp_f
  end interface matrice_hermitienne_vecp

  interface
    module subroutine propres_hermitienne_vecp(this)
      class(matrice_hermitienne_vecp), intent(inout) :: this
    end subroutine propres_hermitienne_vecp
    module subroutine sorties_hermitienne_vecp(this, init)
      class(matrice_hermitienne_vecp), intent(in) :: this
      logical, optional, intent(in)               :: init
    end subroutine sorties_hermitienne_vecp
  end interface
end module mat_hermitienne_vecp
