module mat_real
  use la_precision, only: WP=>DP
  use mat_base

  type, extends(matrice) :: matrice_reelle
    !private
    real(kind=WP),    dimension(:,:), allocatable :: mat
    complex(kind=WP), dimension(:),   allocatable :: valp
    character(len=100) :: format_sortie_mat = "(*(:,es10.3, 2x))"
    character(len=100) :: format_sortie_valp = &
                   '("Valeur propre N.",i2," : (",es10.3,"  , ",es10.3,")")'

  contains
    procedure :: sorties => sorties_reelle
    procedure :: propres => propres_reelle
  end type matrice_reelle

  interface matrice_reelle
    module function matrice_reelle_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_reelle)         :: matrice_reelle_f
    end function matrice_reelle_f
  end interface matrice_reelle

  interface
    module subroutine propres_reelle(this)
      class(matrice_reelle), intent(inout) :: this
    end subroutine propres_reelle
    module subroutine sorties_reelle(this, init)
      class(matrice_reelle), intent(in) :: this
      logical, optional, intent(in)     :: init
    end subroutine sorties_reelle
  end interface
end module mat_real
