submodule(mat_cmplx_vecp) smat_cmplx_vecp
  use f95_lapack, only: GEEV => LA_GEEV
  implicit none

contains

  module function matrice_cmplx_vecp_f(fichier)
    character(len=*), intent(in) :: fichier
    type(matrice_cmplx_vecp)     :: matrice_cmplx_vecp_f
    integer n

    matrice_cmplx_vecp_f%matrice_cmplx = matrice_cmplx(fichier)
    n = matrice_cmplx_vecp_f%get_ordre()
    allocate(matrice_cmplx_vecp_f%vecp(n,n))
  end function matrice_cmplx_vecp_f

  module subroutine propres_cmplx_vecp(this)
    class(matrice_cmplx_vecp), intent(inout) :: this

    call geev(this%mat, this%valp, VR=this%vecp)
  end subroutine propres_cmplx_vecp

  module subroutine sorties_cmplx_vecp(this, init)
    class(matrice_cmplx_vecp), intent(in) :: this
    logical,         optional, intent(in) :: init
    integer i
 
    call this%matrice_cmplx%sorties(init)
    print '(//, t20, a, /)', "Vecteurs propres"
    do i=1,size(this%vecp,1)
      print this%format_sortie_vecp, this%vecp(i,:)
    end do
  end subroutine sorties_cmplx_vecp
end submodule smat_cmplx_vecp
