submodule(mat_hermitienne_vecp) smat_hermitienne_vecp
  use la_precision, only: WP=>DP
  use f95_lapack,   only: HEEV => LA_HEEV
  implicit none

contains

  module function matrice_hermitienne_vecp_f(fichier)
    character(len=*), intent(in)   :: fichier
    type(matrice_hermitienne_vecp) :: matrice_hermitienne_vecp_f
    integer n

    matrice_hermitienne_vecp_f%matrice_hermitienne = matrice_hermitienne(fichier)
    n = matrice_hermitienne_vecp_f%get_ordre()
    allocate(matrice_hermitienne_vecp_f%vecp(n,n))
  end function matrice_hermitienne_vecp_f

  module subroutine propres_hermitienne_vecp(this)
    class(matrice_hermitienne_vecp), intent(inout) :: this
    REAL(WP), DIMENSION(:), ALLOCATABLE :: W
    integer n

    n = this%get_ordre()
    allocate(W(n))
    call heev(this%mat, w, JOBZ='V')
    this%valp(:) = W(:)
    this%vecp(:,:) = this%mat(:,:)
    deallocate(W)
  end subroutine propres_hermitienne_vecp

  module subroutine sorties_hermitienne_vecp(this, init)
    class(matrice_hermitienne_vecp), intent(in) :: this
    logical,               optional, intent(in) :: init
    integer i

    call this%matrice_cmplx%sorties(init)
    print '(//, t20, a, /)', "Vecteurs propres"
    do i=1,size(this%vecp,1)
      print trim(this%format_sortie_vecp), this%vecp(i,:)
    end do
  end subroutine sorties_hermitienne_vecp
end submodule smat_hermitienne_vecp
