submodule(mat_real) smat_real
  use la_precision, only: WP=>DP
  use f95_lapack,   only: GEEV => LA_GEEV, SYEV => LA_SYEV
  implicit none

contains

  module function matrice_reelle_f(fichier)
    character(len=*), intent(in) :: fichier
    character(len=30)            :: type_matrice
    type(matrice_reelle)         :: matrice_reelle_f
    integer n, i, j, unite

    open( newunit=unite,         &
          file=fichier,          &
          action="read",         &
          form="formatted",      &
          access="sequential" )
    read(unit=unite, fmt='(a,/,i4)') type_matrice, n
    matrice_reelle_f%matrice%ordre = n
    matrice_reelle_f%type = type_matrice
    allocate(matrice_reelle_f%mat(n, n))
    allocate(matrice_reelle_f%valp(n))
    read(unit=unite, fmt=*) ((matrice_reelle_f%mat(i,j),j=1,n),i=1,n)
    close(unit=unite)
    call matrice_reelle_f%sorties(init=.true.)
  end function matrice_reelle_f

  module subroutine propres_reelle(this)
    class(matrice_reelle), intent(inout) :: this
    REAL(WP), DIMENSION(:), ALLOCATABLE :: WR, WI
    integer n

    n = this%get_ordre()
    allocate(wr(n), wi(n))
    call geev(this%mat, WR, WI)
    this%valp(:) = cmplx(WR(:), WI(:), kind=WP)
    deallocate(WR, WI)
  end subroutine propres_reelle

  module subroutine sorties_reelle(this, init)
    class(matrice_reelle), intent(in) :: this
    logical,     optional, intent(in) :: init
    logical init_loc
    integer i

    if (     present(init)) init_loc = init
    if (.NOT.present(init)) init_loc = .false.

    if (init_loc) then
      print '(//, t20, a, /)', this%type
      do i=1,size(this%mat,1)
        print trim(this%format_sortie_mat), this%mat(i,:)
      end do
    else
      print '(//, t20, "Valeurs propres", /)'
      do i=1,size(this%valp)
        print trim(this%format_sortie_valp), i, this%valp(i)
      end do
    end if
  end subroutine sorties_reelle
end submodule smat_real
