module mat_cmplx
  use mat_base
  integer, parameter :: WP=kind(1.0d0)

  type, extends(matrice) :: matrice_cmplx
    private
    complex(kind=WP), dimension(:,:), allocatable :: mat
    complex(kind=WP), dimension(:),   allocatable :: valp
    character(len=100) :: format_sortie_mat = &
                   '(*(:,"(",f6.3,",",f6.3,")",1x))'
    character(len=100) :: format_sortie_valp = &
                   '("Valeur propre N.",i2," : (",es10.3,"  , ",es10.3,")")'
  contains
    procedure :: propres => propres_cmplx
    procedure :: sorties => sorties_cmplx
  end type matrice_cmplx

  type, extends(matrice_cmplx) :: matrice_cmplx_vecp
    private
    complex(kind=WP), dimension(:,:), allocatable :: vecp
    character(len=100) :: format_sortie_vecp = &
                   '(*(:,"(",f6.3,",",f6.3,")",1x))'
  contains
    procedure :: propres => propres_cmplx_vecp
    procedure :: sorties => sorties_cmplx_vecp
  end type matrice_cmplx_vecp

  type, extends(matrice_cmplx) :: matrice_hermitienne
  contains
    procedure :: propres => propres_hermitienne
  end type matrice_hermitienne

  type, extends(matrice_hermitienne) :: matrice_hermitienne_vecp
    private
    complex(kind=WP), dimension(:,:), allocatable :: vecp
    character(len=100) :: format_sortie_vecp = &
                   '(*(:,"(",f6.3,",",f6.3,")",1x))'
  contains
    procedure :: propres => propres_hermitienne_vecp
    procedure :: sorties => sorties_hermitienne_vecp
  end type matrice_hermitienne_vecp

  interface matrice_cmplx
    module function matrice_cmplx_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_cmplx)          :: matrice_cmplx_f
    end function matrice_cmplx_f
  end interface matrice_cmplx

  interface matrice_cmplx_vecp
    module function matrice_cmplx_vecp_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_cmplx_vecp)     :: matrice_cmplx_vecp_f
    end function matrice_cmplx_vecp_f
  end interface matrice_cmplx_vecp

  interface matrice_hermitienne
    module function matrice_hermitienne_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_hermitienne)    :: matrice_hermitienne_f
    end function matrice_hermitienne_f
  end interface matrice_hermitienne

  interface matrice_hermitienne_vecp
    module function matrice_hermitienne_vecp_f(fichier)
      character(len=*), intent(in)   :: fichier
      type(matrice_hermitienne_vecp) :: matrice_hermitienne_vecp_f
    end function matrice_hermitienne_vecp_f
  end interface matrice_hermitienne_vecp

  interface
    module subroutine propres_cmplx(this)
      class(matrice_cmplx), intent(inout) :: this
    end subroutine propres_cmplx
    module subroutine sorties_cmplx(this, init)
      class(matrice_cmplx), intent(in) :: this
      logical, optional, intent(in)    :: init
    end subroutine sorties_cmplx

    module subroutine propres_cmplx_vecp(this)
      class(matrice_cmplx_vecp), intent(inout) :: this
    end subroutine propres_cmplx_vecp
    module subroutine sorties_cmplx_vecp(this, init)
      class(matrice_cmplx_vecp), intent(in) :: this
      logical, optional, intent(in)         :: init
    end subroutine sorties_cmplx_vecp

    module subroutine propres_hermitienne(this)
      class(matrice_hermitienne), intent(inout) :: this
    end subroutine propres_hermitienne

    module subroutine propres_hermitienne_vecp(this)
      class(matrice_hermitienne_vecp), intent(inout) :: this
    end subroutine propres_hermitienne_vecp
    module subroutine sorties_hermitienne_vecp(this, init)
      class(matrice_hermitienne_vecp), intent(in) :: this
      logical, optional, intent(in)               :: init
    end subroutine sorties_hermitienne_vecp
  end interface
end module mat_cmplx
