program prog
  call traitement
end program prog

subroutine traitement
  use ISO_FORTRAN_ENV, only : ERROR_UNIT
  use mat_real
  use mat_cmplx
  implicit none
  class(matrice), allocatable :: objet_mat
  integer                     :: nb_matrices, n
  integer                     :: unite, stat
  character(len=100)          :: type_matrice, fichier_donnees
  character(len=512)          :: message
  logical                     :: avec_vp
  character(len=*), parameter :: prompt = &
                    "Appuyer sur la touche Entre pour continuer> "

  open ( newunit=unite,           &
         file="matrices.data", &
         form="formatted",     &
         access="sequential",  &
         action="read" )
  read(unit=unite, fmt=*) nb_matrices
  do n=1,nb_matrices
    read( unit=unite, fmt=*, iostat=stat, iomsg=message ) &
                type_matrice, avec_vp, fichier_donnees
    if ( stat /= 0 ) then
      if ( stat > 0 ) write( ERROR_UNIT, * ) "Erreur I/O : ", message
      exit
    end if
    select case ( type_matrice )
      case ( "Real" )
        if ( .not. avec_vp ) then
          objet_mat = matrice_reelle(fichier_donnees)
        else
          objet_mat = matrice_reelle_vecp(fichier_donnees)
        end if
      case ( "RealSym" )
        if ( .not. avec_vp ) then
          objet_mat = matrice_reelle_sym(fichier_donnees)
        else
          objet_mat = matrice_reelle_sym_vecp(fichier_donnees)
        end if
      case ( "Complex" )
        if ( .not. avec_vp ) then
          objet_mat = matrice_cmplx(fichier_donnees)
        else
          objet_mat = matrice_cmplx_vecp(fichier_donnees)
        end if
      case ( "Hermitian" )
        if ( .not. avec_vp ) then
          objet_mat = matrice_hermitienne(fichier_donnees)
        else
          objet_mat = matrice_hermitienne_vecp(fichier_donnees)
        end if
    end select
    call calculs(objet_mat)
    call objet_mat%sorties
    deallocate( objet_mat )
    write( ERROR_UNIT, "(///,(a))" ) &
                "<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>", &
                "<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>", &
                "<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>", &
                "<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>"
    write( ERROR_UNIT, advance='no', fmt='(a)' ) prompt; read *
  end do
  close(unit=unite)
end subroutine traitement
