module mat_base
  type, abstract :: matrice
    private
    character(len=:), allocatable, public :: type
    integer, public :: ordre
  contains
    procedure, NON_OVERRIDABLE :: get_ordre
    procedure(proto_propres), deferred :: propres
    procedure(proto_sorties), deferred :: sorties
  end type matrice

  abstract interface
    subroutine proto_propres(this)
      import matrice
      class(matrice), intent(inout) :: this
    end subroutine proto_propres
    subroutine proto_sorties(this, init)
      import matrice
      class(matrice), intent(in)    :: this
      logical, optional, intent(in) :: init
    end subroutine proto_sorties
  end interface

  interface assignment(=)
    module procedure affect
  end interface

contains

  subroutine affect(a, b)
    class(matrice), allocatable, intent(out) :: a
    class(matrice),              intent(in)  :: b

    allocate(a, source=b)
  end subroutine affect

  function get_ordre( this )
    class(matrice), intent(in) :: this
    integer get_ordre

    get_ordre = this%ordre
  end function get_ordre
  
  subroutine calculs( a )
    class(matrice), intent(inout) :: a

    call a%propres
  end subroutine calculs
end module mat_base
