program inter
  use ISO_C_BINDING, only : C_PTR, C_CHAR, C_NULL_CHAR, C_F_POINTER
  implicit none

  interface
    subroutine C_chaine( p ) bind(C)
      import C_PTR
      type(C_PTR) :: p
    end subroutine C_chaine
    subroutine C_chaine_free( p ) bind(C)
      import C_PTR
      type(C_PTR), value :: p
    end subroutine C_chaine_free
  end interface
  
  type(C_PTR) :: ptr
  character(len=:,kind=C_CHAR), allocatable :: chaine

  call c_chaine( ptr )
  chaine = recup_chaine( ptr )
  print *, "Longueur chaine : ", len(chaine)
  print *, "chaine          : ", chaine

contains

  function recup_chaine( ptr )
    type(C_PTR) :: ptr
    character(len=:,kind=C_CHAR), allocatable :: recup_chaine
    character(len=:,kind=C_CHAR), pointer     :: chaine
    integer i, ierr

    call C_F_POINTER( CPTR=ptr, FPTR=chaine )
    i = 1
    do while( chaine(i:i) /= C_NULL_CHAR )
      i = i + 1
    end do
    recup_chaine = chaine(1:i-1)
    call c_chaine_free( ptr )
  end function recup_chaine
end program inter
