module mat_base
  type, abstract :: matrice
    private
    character(len=:), allocatable, public :: type
    integer, public :: ordre
  contains
    procedure, NON_OVERRIDABLE :: get_ordre
    procedure(proto_sorties), deferred :: sorties
    procedure(proto_propres), deferred :: propres
  end type matrice

  abstract interface
    subroutine proto_propres(this)
      import matrice
      class(matrice), intent(inout) :: this
    end subroutine proto_propres
    subroutine proto_sorties(this, init)
      import matrice
      class(matrice), intent(in)    :: this
      logical, optional, intent(in) :: init
    end subroutine proto_sorties
  end interface

  interface
    integer module function get_ordre(this)
      class(matrice), intent(in) :: this
    end function get_ordre
    module subroutine calculs(a)
      class(matrice), intent(inout) :: a
    end subroutine calculs
  end interface

  interface assignment(=)
    module subroutine affect(a, b)
      class(matrice), allocatable, intent(out) :: a
      class(matrice),              intent(in)  :: b
    end subroutine affect
  end interface
end module mat_base
