MODULE F95_LAPACK
  INTERFACE LA_SYEV
    SUBROUTINE SSYEV_F95( A, W, JOBZ, UPLO, INFO )
      USE LA_PRECISION, ONLY: WP => SP
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: W(:)
    END SUBROUTINE SSYEV_F95
  
    SUBROUTINE DSYEV_F95( A, W, JOBZ, UPLO, INFO )
      USE LA_PRECISION, ONLY: WP => DP
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: W(:)
    END SUBROUTINE DSYEV_F95
  END INTERFACE
  
  INTERFACE LA_HEEV
    SUBROUTINE CHEEV_F95( A, W, JOBZ, UPLO, INFO )
      USE LA_PRECISION, ONLY: WP => SP
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      COMPLEX(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: W(:)
    END SUBROUTINE CHEEV_F95
  
    SUBROUTINE ZHEEV_F95( A, W, JOBZ, UPLO, INFO )
      USE LA_PRECISION, ONLY: WP => DP
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      COMPLEX(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: W(:)
    END SUBROUTINE ZHEEV_F95
  END INTERFACE
  
  INTERFACE LA_GEEV
    SUBROUTINE SGEEV_F95( A, WR, WI, VL, VR, INFO )
      USE LA_PRECISION, ONLY: WP => SP
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: WR(:), WI(:)
      REAL(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
    END SUBROUTINE SGEEV_F95
    
    SUBROUTINE DGEEV_F95( A, WR, WI, VL, VR, INFO )
      USE LA_PRECISION, ONLY: WP => DP
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: WR(:), WI(:)
      REAL(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
    END SUBROUTINE DGEEV_F95
    
    SUBROUTINE CGEEV_F95( A, W, VL, VR, INFO )
      USE LA_PRECISION, ONLY: WP => SP
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      COMPLEX(WP), INTENT(INOUT) :: A(:,:)
      COMPLEX(WP), INTENT(OUT) :: W(:)
      COMPLEX(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
    END SUBROUTINE CGEEV_F95
    
    SUBROUTINE ZGEEV_F95( A, W, VL, VR, INFO )
      USE LA_PRECISION, ONLY: WP => DP
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      COMPLEX(WP), INTENT(INOUT) :: A(:,:)
      COMPLEX(WP), INTENT(OUT) :: W(:)
      COMPLEX(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
    END SUBROUTINE ZGEEV_F95
  END INTERFACE
END MODULE F95_LAPACK
